<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * PayU Hungary Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2013 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 Nov 2014
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
if (!class_exists('PayUHungaryLiveUpdate'))
require(str_ireplace("administrator","",JPATH_BASE).DS.'plugins'.DS.'vmpayment'.DS.'payuhungaryforvirtuemart'.DS.'PayUPayment.class.php');

class plgVmPaymentPayuHungaryForVirtuemart extends vmPSPlugin {

	public static $_this = false;

	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
    
		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; 
		$this->_tableId = 'id'; 
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment PayU Hungary Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
	    'id' => ' INT(11) unsigned NOT NULL AUTO_INCREMENT ',
	    'virtuemart_order_id' => ' int(1) UNSIGNED DEFAULT NULL',
	    'order_number' => ' char(32) DEFAULT NULL',
	    'virtuemart_paymentmethod_id' => ' mediumint(1) UNSIGNED DEFAULT NULL',
	    'payment_name' => 'varchar(5000)',
	    'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    'payment_currency' => 'char(3) ',
	    'cost_per_transaction' => ' decimal(10,2) DEFAULT NULL ',
	    'cost_percent_total' => ' decimal(10,2) DEFAULT NULL ',
	    'tax_id' => ' smallint(1) DEFAULT NULL'
		);
		return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=payuhungaryforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'payuhungarylic'=>$lic),'payuhungaryforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your PayU - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('payuhungarylic'=>'','dchk'=>''),'payuhungaryforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    $params1  = $this->getParams('payuhungaryforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['payuhungarylic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    //print_r($params1);
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your PayU Hungary - Payment Gateway License Code', 'error');
        $this->setParams(array('payuhungarylic'=>'','dchk'=>''),'payuhungaryforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
          $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
          if($chk!=$dchk)//check
          {
            //$this->setParams(array('payuhungarylic'=>'','dchk'=>''),'payuhungaryforvirtuemart');
            $application->enqueueMessage('Provided License code is wrong', 'error');
            return;
          }
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if($method->payu_password=='')
    {
      $params1  = $this->getParams('payuhungaryforvirtuemart');
      $method->payu_password=$params1['payu_password'];
    }
    if (empty($method->payu_user)) {
			vmInfo(JText::_('PayU Merchant ID Missing!!!'));
			return false;
		}
		if (empty($method->payu_password)) {
			vmInfo(JText::_('PayU Secret Key Missing!!!'));
			return false;
		}
    
    $return_url= JURI::root(). 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid');
    $cancel_url= JURI::root(). 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginuserpaymentcancel&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid');
    if($method->payu_password=='')
    {
      $params1  = $this->getParams('payuhungaryforvirtuemart');
      $method->payu_password=$params1['payu_password'];
    }
    $config = array(
    	'MERCHANT' => $method->payu_user,																		//merchant account ID
    	'SECRET_KEY' => $method->payu_password,																		//secret key for account ID	
    	'METHOD' => "",																			//payment method	 empty -> select payment method on PayU payment page OR [ CCVISAMC, WIRE, CASH, PAYU_MOBILE ]
    	'ORDER_DATE' => date("Y-m-d H:i:s"),													//date of transaction
    	'LOGGER' => false,																		//transaction log
    	'LOG_PATH' => 'log',																	//path of log file
    	'BACK_REF' => $return_url,						//url of payu payment backref page
    	'TIMEOUT_URL' => $cancel_url,					//url of payu payment timeout page
    	'ORDER_TIMEOUT' => 900,
    	'LANGUAGE' => $method->payu_lang
    );
    
    $currency_code_arr=array('HUF','EUR','USD');
    if(!in_array($currency_code_3,$currency_code_arr))
    {
      $currency_code_3='HUF';
    }
    if($method->payu_currency!="" && $method->payu_currency!=$currency_code_3)
    {
      $currency_code_3=$method->payu_currency;
    }
    $myOrderRef	= $order['details']['BT']->order_number;
    $lu = new PayUHungaryLiveUpdate($config);
    $lu->setField("ORDER_DATE", $config['ORDER_DATE']);
  	$lu->setField("BACK_REF", $config['BACK_REF']);
  	$lu->setField("TIMEOUT_URL", $config['TIMEOUT_URL']);
  	$lu->setField("ORDER_TIMEOUT", $config['ORDER_TIMEOUT']);
    $lu->setField("PAY_METHOD", '');
		$lu->setField("AUTOMODE", 0);
    $lu->setField("ORDER_REF", $myOrderRef);
  	$lu->setField("PRICES_CURRENCY", $currency_code_3);
  	$lu->setField("ORDER_SHIPPING", 0); 
  	$lu->setField("LANGUAGE", $config['LANGUAGE']);
  	$lu->setField("ORDER_PRICE_TYPE", "GROSS");
    
    if($order['details']['BT']->coupon_code !="")
    {
      $discount=round(($order['details']['BT']->coupon_discount),2);
      if($discount<0)
        $discount=$discount*-1;
      $lu->setField("DISCOUNT", number_format($discount,2)); 
		}
    
    $vat_amnt=0;
    if(isset($order['details']['BT']->order_billTax))
    {
      $tmp_arr=json_decode($order['details']['BT']->order_billTax);
      $one="1";
      if(isset($tmp_arr->$one))
      {
        $vat_amnt=$tmp_arr->$one->calc_value;
      }
      $vat_amnt=round($vat_amnt);
    }
$vat_amnt=0;//it adds tax value on PayU website, not included
    foreach($order['items'] as $product)
    {
      $lu->addProduct(array(
    		'name' => $product->order_item_name,								//product name [ string ]
    		'code' => $product->order_item_sku,							//merchant systemwide unique product ID [ string ]
    		'info' => '',				//product description [ string ]
    		'price' => (int)ceil(round($product->product_final_price,2)), 								//product price [ HUF: integer | EUR, USD decimal 0.00 ]
    		'vat' => $vat_amnt,										//product tax rate [ in case of gross price: 0 ] (percent)
    		'qty' => $product->product_quantity										//product quantity [ integer ] 
    	));
    }
    if(($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax)>0)
    {
      $lu->addProduct(array(
    		'name' => 'Shipment Fee',								//product name [ string ]
    		'code' => 'SPTFEE',							//merchant systemwide unique product ID [ string ]
    		'info' => '',				//product description [ string ]
    		'price' => (int)ceil(round(($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax),2)),
    		'vat' => $vat_amnt,										//product tax rate [ in case of gross price: 0 ] (percent)
    		'qty' => 1										//product quantity [ integer ] 
    	));
		}
    if(($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax)>0)
		{
      $lu->addProduct(array(
    		'name' => 'Payment Fee',								//product name [ string ]
    		'code' => 'PMTFEE',							//merchant systemwide unique product ID [ string ]
    		'info' => '',				//product description [ string ]
    		'price' => (int)ceil(round(($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax),2)),
    		'vat' => $vat_amnt,										//product tax rate [ in case of gross price: 0 ] (percent)
    		'qty' => 1										//product quantity [ integer ] 
    	));
		}
    //if($method->payu_test=='LIVE')
    //{
  	// $lu->setField("TESTORDER", "FALSE");
    //}
    if($usrBT->phone_1=="" && $usrBT->phone_2!="")
    {
      $usrBT->phone_1=$usrBT->phone_2;
    }
    if($usrST->phone_1=="" && $usrST->phone_2!="")
    {
      $usrST->phone_1=$usrST->phone_2;
    }
  	$lu->setField("BILL_FNAME", $usrBT->first_name);
  	$lu->setField("BILL_LNAME", $usrBT->last_name);
  	$lu->setField("BILL_EMAIL", $usrBT->email); 
  	$lu->setField("BILL_PHONE", $usrBT->phone_1);
  	$lu->setField("BILL_COUNTRYCODE", ShopFunctions::getCountryByID($usrBT->virtuemart_country_id,'country_2_code'));
  	$lu->setField("BILL_STATE", isset($usrBT->virtuemart_state_id) ? ShopFunctions::getStateByID($usrBT->virtuemart_state_id,'state_name') : '');
  	$lu->setField("BILL_CITY", $usrBT->city); 
  	$lu->setField("BILL_ADDRESS", $usrBT->address_1); 
  	$lu->setField("BILL_ADDRESS2", $usrBT->address_2);
  	$lu->setField("BILL_ZIPCODE", $usrBT->zip);
    
    $lu->setField("DELIVERY_FNAME", $usrST->first_name); 
    $lu->setField("DELIVERY_LNAME", $usrST->last_name); 
    $lu->setField("DELIVERY_EMAIL", $usrBT->email); 
    $lu->setField("DELIVERY_PHONE", $usrST->phone_1); 
    $lu->setField("DELIVERY_COUNTRYCODE", ShopFunctions::getCountryByID($usrST->virtuemart_country_id,'country_2_code'));
    $lu->setField("DELIVERY_STATE", isset($usrST->virtuemart_state_id) ? ShopFunctions::getStateByID($usrST->virtuemart_state_id,'state_name') : '');
    $lu->setField("DELIVERY_CITY", $usrST->city);
    $lu->setField("DELIVERY_ADDRESS", $usrST->address_1); 
    $lu->setField("DELIVERY_ADDRESS2", $usrST->address_2);
    $lu->setField("DELIVERY_ZIPCODE", $usrST->zip);
    
		$lu->logger = $config['LOGGER'];
	  $lu->log_path = $config['LOG_PATH'];
    
		$PayU_button='Click here to Pay';
    $html = $lu->createHtmlForm('PayUForm', 'auto', $PayU_button);	// format: link, button, auto (auto is redirects to payment page immediately )
	  
		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		
		$this->storePSPluginInternalData($dbValues);
		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		$mainframe = JFactory::getApplication();
    $mainframe->enqueueMessage('Your order timed out', 'error');
    $mainframe->redirect('index.php?option=com_virtuemart&view=cart');
    exit;
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) {
	
	  if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
    
		$payment_name = $this->renderPluginName($method);
    
    $db = JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    $order_url=JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$order_number.'&order_pass='.$result->order_pass;
    if($method->payu_password=='')
    {
      $params1  = $this->getParams('payuhungaryforvirtuemart');
      $method->payu_password=$params1['payu_password'];
    }
    $config = array(
    	'MERCHANT' => $method->payu_user,																		//merchant account ID
    	'SECRET_KEY' => $method->payu_password,																		//secret key for account ID	
    	'METHOD' => "",																			//payment method	 empty -> select payment method on PayU payment page OR [ CCVISAMC, WIRE, CASH, PAYU_MOBILE ]
    	'ORDER_DATE' => date("Y-m-d H:i:s"),													//date of transaction
    	'LOGGER' => false,																		//transaction log
    	'LOG_PATH' => 'log',																	//path of log file
    	'ORDER_TIMEOUT' => 900,
    	'LANGUAGE' => $method->payu_lang
    );
    
    if ($method->payu_lang=='HU') {
			define("LANGUAGE", "HU");
			define("LIVEUPDATE_TEST_TRANSACTION", "LiveUpdate teszt tranzakcio");
			define("BACKREF_REDIRECT_PAGE", "BackRef visszatero oldal");
			define("TIMEOUT_PAGE", "Idotullepes");
			define("SET_UP_MERCHANT", "Az sdk/config.php fajlban allitsa be a kereskedoi azonositojat (MERCHANT)");
			define("SET_UP_SECRET_KEY", "Az sdk/config.php fajlban allitsa be a titkos kulcsat (SECRET_KEY)");	
			define("METHOD_CCVISAMC", "Bankkartya");
			define("METHOD_PAYU_MOBILE", "PayU mobile");
			define("METHOD_WIRE", "atutalas");
			define("METHOD_CASH", "Utanvetel");
			define("METHOD_ON_PAYMENT_PAGE", "Fizeto oldali kivalasztas");
			define("PAYMENT_METHOD", "Fizetesi mod");
			define("SETTINGS", "Beallitas");
			define("PAYMENT_BUTTON", "PayU online fizetes inditasa");
			define("SELECT_ON_PAYMENT_PAGE", "a PayU fizetooldalon lehet kivalasztani");
			define("CARDS_FOR_TEST", "Teszt kartyak");		
			define("SUCCESFUL_PAYMENT", "Sikeres fizetes");
			define("UNSUCCESFUL_PAYMENT", "Sikertelen fizetes");
			define("CARD_NUMBER", "Kartya szam");
			define("EXPIRATION", "Lejarat");
			define("ANY_THREE_NUMBERS", "tetszoleges harom szam");
			define("ANY_LATER", "tetszoleges kesobbi datum");
			define("SUCCESSFUL_CARD_AUTHORIZATION", "Sikeres kartya ellenorzes.");
			define("SUCCESSFUL_WIRE", "Sikeres megrendeles. <br/>Az utalas megerkezese utan lesz teljesitve a megrendeles");
			define("SUCCESSFUL_CASH", "Sikeres megrendeles. <br/>Fizetes a kezbesiteskor");
			define("WAITING_FOR_IPN", "Megerositesre var!");
			define("CONFIRMED_IPN", "IPN megerositve, sikeres fizetes!");
			define("CONFIRMED_WIRE", "Beerkezett atutalas");
			define("UNSUCCESSFUL_TRANSACTION", "Sikertelen tranzakcio.");
			define("UNSUCCESSFUL_NOTICE", "Kerjuk, ellenorizze a tranzakcio soran megadott adatok helyesseget.<br>Amennyiben minden adatot helyesen adott meg, a visszautasitas okanak kivizsgalasa kapcsan kerjuk, sziveskedjen kapcsolatba lepni kartyakibocsato bankjaval.");
			define("END_OF_TRANSACTION", "Vege a tranzakcionak.");
			define("BACKREF_DATE", "Datum");
			define("DATE", "Datum");
			define("ORDER_ID", "Megrendeles azonosito");
			define("PAYREFNO", "PayU referenciaszam");
			define("STATUS", "Statusz");
			define("PAYMENT_TEST", "Teszt fizetes");
			define("DO_MORE_TESTS", "Vegezzen tovabbi teszteket!");
			define("DO_SUCCESSFUL_PAYMENT", "Teszteljen sikeres fizetest!");
			define("DO_UNSUCCESSFUL_PAYMENT", "Teszteljen sikertelen fizetest!");
			define("DO_CANCEL_PAYMENT", "Teszteljen megszakitott fizetest (\"Vissza\" gomb a fizetooldalon)!");
			define("ABORTED_TRANSACTION", "Megszakitott tranzakcio");
			define("TIMEOUT_TRANSACTION", "Idotullepeses tranzakcio	");
			define("TIMEOUT_PAGE_TITLE", "Idotullepes, vagy megszakitas");
			define("TIMEOUT_NOTICE", "On megszakitotta a fizetest, vagy lejart a tranzakcio maximalis ideje!");
		}
		else
    {
			define("LANGUAGE", "EN");
			define("LIVEUPDATE_TEST_TRANSACTION", "LiveUpdate test transaction");
			define("BACKREF_REDIRECT_PAGE", "BackRef redirect page");
			define("TIMEOUT_PAGE", "Timeout page");
			define("SET_UP_MERCHANT", "Please define merchant id (MERCHANT) in sdk/config.php.");
			define("SET_UP_SECRET_KEY", "Please define secret key (SECRET_KEY) in sdk/config.php.");
			define("METHOD_CCVISAMC", "Credit card");
			define("METHOD_PAYU_MOBILE", "PayU mobile");
			define("METHOD_WIRE", "Wire transfer");
			define("METHOD_CASH", "Cash on delivery");
			define("METHOD_ON_PAYMENT_PAGE", "Select on payment page");
			define("PAYMENT_METHOD", "Payment method");
			define("SETTINGS", "Settings");
			define("PAYMENT_BUTTON", "Start PayU online payment");
			define("SELECT_ON_PAYMENT_PAGE", "select on PayU payment page");
			define("CARDS_FOR_TEST", "Cards for test");
			define("SUCCESFUL_PAYMENT", "Successful payment");
			define("UNSUCCESFUL_PAYMENT", "Unsuccessful payment");
			define("CARD_NUMBER", "Card number");
			define("EXPIRATION", "Card expiration date");
			define("ANY_THREE_NUMBERS", "any three numbers");	
			define("ANY_LATER", "any later");			
			define("SUCCESSFUL_CARD_AUTHORIZATION", "Successful card authorization.");
			define("SUCCESSFUL_WIRE", "Successful order.<br/>After successful wire transfer will be fulfilled your order.");
			define("SUCCESSFUL_CASH", "Successful order. <br/>Pay on delivery");
			define("WAITING_FOR_IPN", "Waiting for confirmation!");
			define("CONFIRMED_IPN", "IPN was confirmed, payment is successful!");
			define("CONFIRMED_WIRE", "Wire transfer has been received");
			define("UNSUCCESSFUL_TRANSACTION", "Unsuccessful transaction.");
			define("UNSUCCESSFUL_NOTICE", "Please check the data entered during the transaction.<br/>If you submitted every data correctly, please contact your account holder financial institute.");
			define("END_OF_TRANSACTION", "End of transaction.");
			define("BACKREF_DATE", "Date");
			define("DATE", "Date");
			define("ORDER_ID", "Order ID");
			define("PAYREFNO", "PayU reference number");
			define("STATUS", "Status");
			define("PAYMENT_TEST", "Payment test");
			define("DO_MORE_TESTS", "Do more tests!");
			define("DO_SUCCESSFUL_PAYMENT", "Make test with card for successful payments");
			define("DO_UNSUCCESSFUL_PAYMENT", "Make test with card for unsuccessful payments");
			define("DO_CANCEL_PAYMENT", "Make cancel payment (\"Cancel\" button on payment page)!");
			define("ABORTED_TRANSACTION", "Cancel on payment page");
			define("TIMEOUT_TRANSACTION", "Timeout");
			define("TIMEOUT_PAGE_TITLE", "Timeout or cancel");
			define("TIMEOUT_NOTICE", "On megszakitotta a fizetest, vagy lejart a tranzakcio maximalis ideje!");
		}
    $payrefno=isset($_GET['payrefno'])?" ".PAYREFNO.": ".$_GET['payrefno']:"";
    $cart = VirtueMartCart::getCart();
    $app = JFactory::getApplication();
    $backref = new PayUHungaryBackRef($config);
  	$backref->order_ref = $_REQUEST['order_ref'];
  	$backref->logger = $config['LOGGER'];
  	$backref->log_path = $config['LOG_PATH'];
  	if($backref->checkResponse())
    {
      /*
      if($method->payu_wait_ipn=='yes')
      {
      */
    		$backStatus = $backref->backStatusArray;
    		if ($backStatus['PAYMETHOD']=='Visa/MasterCard/Eurocard'||$backStatus['PAYMETHOD']=='PayU mobile') {
          $app->enqueueMessage(SUCCESSFUL_CARD_AUTHORIZATION.$payrefno);
    			if ($backStatus['ORDER_STATUS']=='IN_PROGRESS') {
            $cart->emptyCart();
            $app->enqueueMessage(WAITING_FOR_IPN.$payrefno,'notice');
            $app->redirect($order_url);
      			exit;
    			} elseif ($backStatus['ORDER_STATUS']=='PAYMENT_AUTHORIZED' || $backStatus['ORDER_STATUS']=='COMPLETED') {
            $cart->emptyCart();
            $app->enqueueMessage(CONFIRMED_IPN.$payrefno);
            $app->redirect($order_url);
      			exit;
    			}
    		}
    		elseif ($backStatus['PAYMETHOD']=='Bank/Wire transfer') {
          $app->enqueueMessage(SUCCESSFUL_WIRE.$payrefno);
    			if ($backStatus['ORDER_STATUS']=='PAYMENT_AUTHORIZED' || $backStatus['ORDER_STATUS']=='COMPLETED') {
            $cart->emptyCart();
            $app->enqueueMessage(CONFIRMED_WIRE.$payrefno);
            $app->redirect($order_url);
      			exit;
    			} 			
    		}
    		elseif ($backStatus['PAYMETHOD']=='Cash on delivery') {
            $cart->emptyCart();
            $app->enqueueMessage(SUCCESSFUL_CASH.$payrefno);
            $app->redirect($order_url);
      			exit;
    		}
      /*
      }
      else
      {
        $modelOrder = VmModel::getModel('orders');
    		$order = array();
    		$order['customer_notified'] = 1;
    		$order['order_status'] = $method->status_success;
    		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
        
        $cart->emptyCart();
        $app->enqueueMessage(SUCCESSFUL_CARD_AUTHORIZATION.$payrefno);
        $app->redirect($order_url);
  			exit;
      }
      */
  	}
    else
    {
  		$backStatus = $backref->backStatusArray;
      $app->enqueueMessage(UNSUCCESSFUL_TRANSACTION.$payrefno,'error');
      $app->enqueueMessage(END_OF_TRANSACTION.$payrefno,'error');
      $app->enqueueMessage(UNSUCCESSFUL_NOTICE.$payrefno,'error');
      $app->redirect($order_url);
			exit;
  	}

		//$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);
		
		$cart->emptyCart();
		return TRUE;
	}
	function _getTablepkeyValue($virtuemart_order_id) {
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function _getPaymentStatus($method, $strStatus) {
		$new_status = '';
		if (strcmp($strStatus, 'OK') == 0) {
			$new_status = $method->status_success;
		}
    elseif (strcmp($strStatus, 'ABORT') == 0) {
			$new_status = $method->status_pending;
		}
    else {
			$new_status = $method->status_canceled;
		}
		return $new_status;
	}
	
	function _getPayuInternalData($virtuemart_order_id, $order_number='') {
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` WHERE ';
		if ($order_number) {
			$q .= " `order_number` = '" . $order_number . "'";
		} else {
			$q .= ' `virtuemart_order_id` = ' . $virtuemart_order_id;
		}

		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject())) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $paymentTable;
	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
    $db = JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
		$html = '<table>' . "\n";
		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
		
    if(isset($result->order_pass))
    {
      $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
    }
    
    $html .= '</table>
    ' . "\n";
    if(isset($result->order_pass))
    {
      $html .= '
      <script type="text/javascript">
      alert("Thank You!");
      window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
      </script>
      ';
    }
    	
		return $html;
	}
	
  function sendMailtoAdmin($msg)
  {
    $mailer = JFactory::getMailer();
    $config = JFactory::getConfig();
    $sender = array( 
        $config->getValue( 'config.mailfrom' ),
        $config->getValue( 'config.fromname' ) );
     
    $mailer->setSender($sender);
    
    $mailer->addRecipient($config->getValue( 'config.mailfrom' ));
    $body   = $msg;
    $mailer->setSubject(juri::base().' - PayU Warning!');
    $mailer->isHTML(true);
    $body=nl2br($body);
    $mailer->setBody($body);
    $send = $mailer->Send();
  }
	function plgVmOnPaymentNotification() {

    //print_r($_POST);
    if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}
		$payu_data = JRequest::get('post');
		if (!isset($payu_data['REFNOEXT'])) {
			return FALSE;
		}
    
		$order_number = $payu_data['REFNOEXT'];
		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($payu_data['REFNOEXT']))) {
			return FALSE;
		}
    
		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			return FALSE;
		}

		$method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		if($method->payu_password=='')
    {
      $params1  = $this->getParams('payuhungaryforvirtuemart');
      $method->payu_password=$params1['payu_password'];
    }
    $config = array(
    	'MERCHANT' => $method->payu_user,																		//merchant account ID
    	'SECRET_KEY' => $method->payu_password,																		//secret key for account ID	
    	'METHOD' => "",																			//payment method	 empty -> select payment method on PayU payment page OR [ CCVISAMC, WIRE, CASH, PAYU_MOBILE ]
    	'ORDER_DATE' => date("Y-m-d H:i:s"),													//date of transaction
    	'LOGGER' => false,																		//transaction log
    	'LOG_PATH' => 'log',																	//path of log file
    	'LANGUAGE' => $method->payu_lang
    );
    
    $ipn = new PayUHungaryIpn($config);
    $order_paid=0;
    if($ipn->validateReceived())
    {
      $order_paid=1;
  	}
    
		$modelOrder = VmModel::getModel('orders');
		$order = array();

		$order['customer_notified'] = 1;

		if ($order_paid == 1) {
			$order['order_status'] = $method->status_success;
		}
    else
    {
      $order['order_status'] = $method->status_canceled;
    }
		$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
    ob_end_clean();
  	echo $ipn->confirmReceived();
    exit;
	}

	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);
		$amount = $cart_prices['salesPrice'];
		$amount_cond = ($amount > 0);
		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id']))
		$address['virtuemart_country_id'] = 0;
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return true;
			}
		}

		return false;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
		return $this->declarePluginParams('payment', $name, $id, $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}

}

// No closing tag
